Package javax.mail

## Interface UIDFolder

All Known Implementing Classes:
  `DefaultFolder`, `GmailFolder`, `IMAPFolder`

    public interface UIDFolder

The `UIDFolder` interface is implemented by Folders that can support the "disconnected" mode of operation, by providing unique-ids for messages in the folder. This interface is based on the IMAP model for supporting disconnected operation.

A Unique identifier (UID) is a positive long value, assigned to each message in a specific folder. Unique identifiers are assigned in a strictly ascending fashion in the mailbox. That is, as each message is added to the mailbox it is assigned a higher UID than the message(s) which were added previously. Unique identifiers persist across sessions. This permits a client to resynchronize its state from a previous session with the server.

Associated with every mailbox is a unique identifier validity value. If unique identifiers from an earlier session fail to persist to this session, the unique identifier validity value must be greater than the one used in the earlier session.

Refer to RFC 2060 for more information. All the Folder objects returned by the default IMAP provider implement the UIDFolder interface. Use it as follows:

>             Folder f = store.getFolder("whatever");
>             UIDFolder uf = (UIDFolder)f;
>             long uid = uf.getUID(msg);

Author:
  Bill Shannon, John Mani

### Nested Class Summary

Nested Classes
`static class` `UIDFolder.FetchProfileItem` A fetch profile item for fetching UIDs.

### Field Summary

Fields
`static long` `LASTUID` This is a special value that can be used as the `end` parameter in `getMessagesByUID(start, end)`, to denote the UID of the last message in the folder.
`static long` `MAXUID` The largest value possible for a UID, a 32-bit unsigned integer.

### Method Summary

All Methods Instance Methods Abstract Methods
`Message` `getMessageByUID​(long uid)` Get the Message corresponding to the given UID.
`Message[]` `getMessagesByUID​(long[] uids)` Get the Messages specified by the given array of UIDs.
`Message[]` `getMessagesByUID​(long start, long end)` Get the Messages specified by the given range.
`long` `getUID​(Message message)` Get the UID for the specified message.
`long` `getUIDNext​()` Returns the predicted UID that will be assigned to the next message that is appended to this folder.
`long` `getUIDValidity​()` Returns the UIDValidity value associated with this folder.

### Field Detail

#### LASTUID

    static final long LASTUID

This is a special value that can be used as the `end` parameter in `getMessagesByUID(start, end)`, to denote the UID of the last message in the folder.

See Also:
  `getMessagesByUID(long, long)`, Constant Field Values

#### MAXUID

    static final long MAXUID

The largest value possible for a UID, a 32-bit unsigned integer. This can be used to fetch all new messages by keeping track of the last UID that was seen and using:

>             Folder f = store.getFolder("whatever");
>             UIDFolder uf = (UIDFolder)f;
>             Message[] newMsgs =
>                     uf.getMessagesByUID(lastSeenUID + 1, UIDFolder.MAXUID);

Since:
  JavaMail 1.6
See Also:
  Constant Field Values

### Method Detail

#### getUIDValidity

    long getUIDValidity​()
                 throws MessagingException

Returns the UIDValidity value associated with this folder.

Clients typically compare this value against a UIDValidity value saved from a previous session to insure that any cached UIDs are not stale.

Returns:
  UIDValidity
Throws:
  `MessagingException` - for failures

#### getMessageByUID

    Message getMessageByUID​(long uid)
                     throws MessagingException

Get the Message corresponding to the given UID. If no such message exists, `null` is returned.

Parameters:
  `uid` - UID for the desired message
Returns:
  the Message object. `null` is returned if no message corresponding to this UID is obtained.
Throws:
  `MessagingException` - for failures

#### getMessagesByUID

    Message[] getMessagesByUID​(long start,
                               long end)
                        throws MessagingException

Get the Messages specified by the given range. The special value LASTUID can be used for the `end` parameter to indicate the UID of the last message in the folder.

Note that `end` need not be greater than `start`; the order of the range doesn't matter. Note also that, unless the folder is empty, use of LASTUID ensures that at least one message will be returned - the last message in the folder.

Parameters:
  `start` - start UID
  `end` - end UID
Returns:
  array of Message objects
Throws:
  `MessagingException` - for failures
See Also:
  `LASTUID`

#### getMessagesByUID

    Message[] getMessagesByUID​(long[] uids)
                        throws MessagingException

Get the Messages specified by the given array of UIDs. If any UID is invalid, `null` is returned for that entry.

Note that the returned array will be of the same size as the specified array of UIDs, and `null` entries may be present in the array to indicate invalid UIDs.

Parameters:
  `uids` - array of UIDs
Returns:
  array of Message objects
Throws:
  `MessagingException` - for failures

#### getUID

    long getUID​(Message message)
         throws MessagingException

Get the UID for the specified message. Note that the message must belong to this folder. Otherwise java.util.NoSuchElementException is thrown.

Parameters:
  `message` - Message from this folder
Returns:
  UID for this message
Throws:
  `NoSuchElementException` - if the given Message is not in this Folder.
  `MessagingException` - for other failures

#### getUIDNext

    long getUIDNext​()
             throws MessagingException

Returns the predicted UID that will be assigned to the next message that is appended to this folder. Messages might be appended to the folder after this value is retrieved, causing this value to be out of date. This value might only be updated when a folder is first opened. Note that messages may have been appended to the folder while it was open and thus this value may be out of date.

If the value is unknown, -1 is returned.

Returns:
  the UIDNEXT value, or -1 if unknown
Throws:
  `MessagingException` - for failures
Since:
  JavaMail 1.6